/*                                                            -*- C -*-
 * Copyright (c) 2004 Takashi Nemoto 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#include <qstring.h>

enum {CF_READY=1, SD_READY=2, NET_READY=4, MAIN_READY=8, MAIN0_READY=16,
      MAIN1_READY=32, MAIN2_READY=64};

#ifdef ZAURUS
struct qpath_struct
{
  const char *path;
  const char *name;
  int id;
};
#else
struct qpath_struct
{
  char *path;
  const char *name;
  int id;
};
#endif

extern struct qpath_struct g_book_path[];
extern struct qpath_struct g_appendix_path[];


class DiskStat {
 public:
  static void enable(int x) { enabled |= x; };
  static void disable() { enabled = 0; };
  static bool enabled_p( int x ) { return (enabled & x)!=0; };
  static int memory(const char *path);
  static const char* mem_text(const char *path);
  static bool checkDiskReady(bool enableSD = true, bool enableCF = true);

  // private:
  static int enabled;
};

