#include "mypushbutton.h"
#include <cstdio>

bool
MyPushButton::eventFilter (QObject *o, QEvent *e)
{
  if (e->type () == QEvent::KeyPress) {
    QKeyEvent *k = (QKeyEvent *)e;
    switch(k->key()) {
    case Qt::Key_Return:
    case Qt::Key_Enter:
      emit clicked();
      return TRUE;
    }
  } else if (e->type () == QEvent::KeyRelease) {
    QKeyEvent *k = (QKeyEvent *)e;
    switch(k->key()) {
    case Qt::Key_Return:
    case Qt::Key_Enter:
      return TRUE;
    }
  }
  return QWidget::eventFilter(o, e);
}

MyPushButton::MyPushButton( QWidget *parent, const char *name) :
  QPushButton(parent, name) {
  installEventFilter (this);
};

MyPushButton::MyPushButton( const QString &text, QWidget *parent, 
			    const char* name) :
  QPushButton(text, parent, name) {
  installEventFilter (this);
};

MyPushButton::MyPushButton( const QIconSet& icon, const QString &text, 
	      QWidget *parent, const char* name) : 
  QPushButton(icon, text, parent, name) {
  installEventFilter (this);
};


