#include "qbookbrowser.h"
#include "qbookentry.h"

QBookBrowser::QBookBrowser (QWidget *parent, const char *name)
  : QTextBrowser (parent, name)
{
}

// Hacks from qtjiten
// original from  http://lists.trolltech.com/qt-interest/2001-06/msg00992.html
void
QBookBrowser::setSource(const QString &name)
{
  QString strTmp = name;
  fprintf(stderr,"StrTmp=%s\n",strTmp.latin1());
  if (strTmp.left(8)=="qbook://") {
    strTmp=strTmp.left(6)+strTmp.mid(8);
  }
  if (strTmp.left(6) == "qbook:")
    {
      int page, offset;
      EB_Position p;
      sscanf(strTmp.latin1(), "qbook:%d_%d", &page, &offset);
      p.page = page;
      p.offset = offset;
      fprintf(stderr,"Link %d:%d\n",page,offset);
      switch(page) {
      case LINK_SOUND:
	emit playSound(offset);
	break;
      case LINK_IMAGE:
	emit showImage(offset);
	break;
      case LINK_MOVIE:
	emit playMovie(offset);
	break;
      case LINK_IMAGE_GROUP:
	emit showImageGroup(offset);
	break;
      default:
	emit goTo(p);
	break;
      }
      return;
    }
  else
    {
      QTextBrowser::setSource(name);
    }
}

int pressed_x, pressed_y;
void QBookBrowser::viewportMousePressEvent( QMouseEvent* e )
{
  pressed_x = e->pos().x();
  pressed_y = e->pos().y();
  QTextBrowser::viewportMousePressEvent(e);
}

void QBookBrowser::viewportMouseMoveEvent( QMouseEvent* e)
{
  if (abs(e->pos().x() - pressed_x) < 5 && 
      abs(e->pos().y() - pressed_y) < 5)
    return;
  pressed_x = -10000;
  pressed_y = -10000;
  QTextBrowser::viewportMouseMoveEvent(e);
}
