#include <stdlib.h>
#include "qbookitem.h"

QBookItem::QBookItem (QListView *parent)
  : QListViewItem (parent)
{
  path = NULL;
  id = -1;
  color = QColor((unsigned int)0x000000);
}

QBookItem::~QBookItem ()
{
  if (path)
    free ((void *)path);
}

void QBookItem::paintCell(
	QPainter *p,
	const QColorGroup &cg,
	int column,
	int width,
	int align
)
{
	QColorGroup tempcg = cg;
	tempcg.setColor(QColorGroup::Foreground, color);
	tempcg.setColor(QColorGroup::Text, color);
	QListViewItem::paintCell(p,tempcg,column,width,align);
}

void QBookItem::setColor(const QString sColor)
{
	color = QColor(sColor.mid(1).toUInt(NULL,16));
}
