/*                                                            -*- C -*-
 * Copyright (c) 2003-2004 Teranishi & Nemoto 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#include "ztenbooklistbase.h"

#ifndef ZTENBOOKLIST_H
#define ZTENBOOKLIST_H

class Zten;
class QAction;
class QToolBar;

class ZtenBookList : public ZtenBookListBase
{
  Q_OBJECT
public:
  ZtenBookList (Zten *zt, QWidget* parent = 0, const char* name = 0, bool modal = TRUE, WFlags fl = 0 );
  ~ZtenBookList ();

  QToolBar* toolBar;
  //  QAction *selectBooksAction, *listDownAction, *listUpAction;
  //  QAction *deleteBookAction, *extensionAction;

  Zten *zten;
 protected:
  virtual bool eventFilter (QObject *o, QEvent *e);
  ButtonState keyState;

 private slots:
  void selectBooks ();
  void listDown ();
  void listUp ();
  void setExtension ();
  void deleteBook ();

  void setPriority0();
  void setPriority1();
  void setPriority2();
  void setPriority3();
  void setPriority4();
  void setPriority5();
  void setPriority6();
  void setPriority7();
  void setPriority8();
  void setPriority9();
  void setPriorityS();
  void setPriorityA();
  void setPriority(int n);
protected slots:
  virtual void accept ();
};

#endif // ZTENBOOKLIST_H
