#include "ztencolor.h"
// #include "ztencolorbase.h"
#include <qhbuttongroup.h>
#include <qlayout.h>
#include <qlabel.h>
#include <qdialog.h>
#include <qcolor.h>
#include <qpushbutton.h>
#include <qslider.h>
#include <qhbox.h>
#include <cstdio>

ZtenColor::ZtenColor (int c, QWidget* parent, const char *name,
			bool modal, WFlags fl):    
  QDialog( parent, name, modal, fl )
{
  setCaption( tr( "Color Select" ) );
  col=c;
  int R=(col&0xff0000)>>16;
  int G=(col&0xff00)>>8;
  int B=(col&0xff);
  
  QVBoxLayout* mainBox=new QVBoxLayout(this);
  mainBox->setSpacing(2);
  mainBox->setMargin(2);

  //  QHBoxLayout* colorBox[8], *box;
  QHButtonGroup* colorBox[8], *bx;
  
  for(int i=0;i<4; i++) {
    //    bx=colorBox[i]=new QHBoxLayout(mainBox);
    bx=colorBox[i]=new QHButtonGroup(this);
    mainBox->addWidget(bx);
    for(int j=0; j<8; j++) {
      QButton *bt;
      const int map[5]={0xff, 0xcc, 0x88, 0x44, 0 };
      char buf[8];
      int r=((j&2)!=0?1:0)*map[i];
      int g=((j&4)!=0?1:0)*map[i];
      int b=((j&1)!=0?1:0)*map[i];
      sprintf(buf,"%X%X%X",r&15,g&15,b&15);
      //      bt=button[i*8+j]=new QPushButton(buf,this);
      //      bt=new QButton(this);

      //      bt=new QPushButton(bx);
      //      bt->setText(buf);
      //      bt->setMinimumSize(30, 20);

      bt=new QPushButton(buf, bx);
      //      bt->setText(buf);
      //      bt->setMinimumSize(30, 20);

      bx->insert(bt, i*8+j);
      buttonColor[i*8+j]=r*0x10000+g*0x100+b;

      QPalette pal;
      QColorGroup cg;
      cg.setColor( QColorGroup::ButtonText, QColor( r, g, b) );
      cg.setColor( QColorGroup::Button, QColor(0xff,0xff,0xff) );
      pal.setActive( cg );
      pal.setInactive( cg );
      pal.setDisabled( cg );
      bt->setPalette(pal);
      // bx->addWidget(bt);
    }
    connect(bx, SIGNAL(clicked(int)), this, SLOT(buttonPressed(int)));
  }

  QHBoxLayout* box=new QHBoxLayout(mainBox);
  QLabel *rLabel=new QLabel(tr("Red:   "), this);
  rSlider=new QSlider(0,255,10,R,QSlider::Horizontal,this);
  box->addWidget(rLabel);
  box->addWidget(rSlider);
  connect(rSlider, SIGNAL(valueChanged(int)), this, SLOT(colorChanged(int)));

  box=new QHBoxLayout(mainBox);
  QLabel *gLabel=new QLabel(tr("Green: "), this);
  gSlider=new QSlider(0,255,10,G,QSlider::Horizontal,this);
  box->addWidget(gLabel);
  box->addWidget(gSlider);
  connect(gSlider, SIGNAL(valueChanged(int)), this, SLOT(colorChanged(int)));

  box=new QHBoxLayout(mainBox);
  QLabel *bLabel=new QLabel(tr("Blue:  "), this);
  bSlider=new QSlider(0,255,10,B,QSlider::Horizontal,this);
  box->addWidget(bLabel);
  box->addWidget(bSlider);
  connect(bSlider, SIGNAL(valueChanged(int)), this, SLOT(colorChanged(int)));

  sampleText1=new QLabel(tr("Sample Text1"), this);
  mainBox->addWidget(sampleText1);
  sampleText2=new QLabel(tr("Sample Text2"), this);
  mainBox->addWidget(sampleText2);

  setSampleColor();
  /*
      QPalette pal;
      QColorGroup cg;
      cg.setColor( QColorGroup::ButtonText, QColor( r, g, b) );
      cg.setColor( QColorGroup::Button, QColor(0xff,0xff,0xff) );
      pal.setActive( cg );
      pal.setInactive( cg );
      pal.setDisabled( cg );
      bt->setPalette(pal);
  */

  /*
  QPalette pal;
  QColorGroup cg;

  cg.setColor( QColorGroup::ButtonText, QColor(0x00,0x00,0x00) );
  cg.setColor( QColorGroup::Button, QColor( 255, 255, 255) );
  pal.setActive( cg );
  pal.setInactive( cg );
  pal.setDisabled( cg );
  Color0_1->setPalette(pal);

  cg.setColor( QColorGroup::ButtonText, QColor(0x00,0x00,0xff) );
  pal.setActive( cg );
  pal.setInactive( cg );
  pal.setDisabled( cg );
  Color1_1->setPalette(pal);

  cg.setColor( QColorGroup::ButtonText, QColor(0xff,0x00,0x00) );
  pal.setActive( cg );
  pal.setInactive( cg );
  pal.setDisabled( cg );
  Color2_1->setPalette(pal);
  */

#ifndef QTOPIA
  QHBox* hbox=new QHBox(this);;
  QPushButton *acceptButton=new QPushButton(tr("Accept"),hbox);
  QPushButton *rejectButton=new QPushButton(tr("Reject"),hbox);
  hbox->setMaximumSize( QSize( 32000, 30 ) );
  connect((QObject *)acceptButton, SIGNAL (clicked()), this, SLOT (accept ()));
  connect((QObject *)rejectButton, SIGNAL (clicked()), this, SLOT (reject ()));
  mainBox->addWidget(hbox);
#endif  

}

void ZtenColor::setSampleColor() {
  int R=(col&0xff0000)>>16;
  int G=(col&0xff00)>>8;
  int B=(col&0xff);

  QPalette pal;
  QColorGroup cg(colorGroup());
  //  cg.setColor( QColorGroup::Text, QColor( R, G, B) );
  cg.setColor( QColorGroup::Foreground, QColor( R, G, B) );
  cg.setColor( QColorGroup::Background, QColor( 0xff, 0xff, 0xff));
  pal.setActive( cg );
  pal.setInactive( cg );
  pal.setDisabled( cg );
  sampleText1->setPalette(pal);
  cg.setColor( QColorGroup::Background, colorGroup().highlight() );
  pal.setActive( cg );
  pal.setInactive( cg );
  pal.setDisabled( cg );
  sampleText2->setPalette(pal);
  
}

void ZtenColor::colorChanged(int /* v */) {
  int r=rSlider->value();
  int g=gSlider->value();
  int b=bSlider->value();
  col=r*0x10000+g*0x100+b;
  setSampleColor();
}

void ZtenColor::buttonPressed(int i) {
  /*
  int r=rSlider->value();
  int g=gSlider->value();
  int b=bSlider->value();
  col=r*0x10000+g*0x100+b;
  */
  int c=buttonColor[i];
  rSlider->setValue((c & 0xff0000)>>16);
  gSlider->setValue((c & 0xff00)>>8);
  bSlider->setValue((c & 0xff));
}


ZtenColor::~ZtenColor() {
}

void ZtenColor::accept() {
  //  ZtenColorBase::accept();
  QDialog::accept();
}

int ZtenColor::color() {
  return col;
}
