#ifndef __ZTEN_CONF_H__
#define __ZTEN_CONF_H__

// #include <qlist.h>
#include <qstring.h>
#include <qobject.h>
// #include <qwidget.h>
// #include <qpe/config.h>
// #include "qbookentry.h"

#define MAX_DIC_GROUPS 10
#define DIC_GROUP_SINGLE MAX_DIC_GROUPS
#define DIC_GROUP_ALL (MAX_DIC_GROUPS+1)
enum { KEYCONF_ZTENV=0, KEYCONF_ZDICT=1, KEYCONF_CUSTOM=2 };
enum { KEYCONF_HIT=0, KEYCONF_HIST=1, KEYCONF_ENTRY=2, KEYCONF_SC1=3, KEYCONF_SCP=4, KEYCONF_COMMANDS=5 };
enum { KEYCONF_UD = 0, KEYCONF_LR = 1, KEYCONF_LG = 2 };
enum { KEYCONF_NONE = 0, KEYCONF_SHIFT=1, KEYCONF_Fn=2, KEYCONF_CTRL=3};

class Zten;
class Config;

struct KeyConfig {
  int cursor;
  int mod;
  KeyConfig(int c=0, int m=0) : cursor(c), mod(m) {};
};

class ZtenConf : QObject {
  Q_OBJECT

 public:
  ZtenConf(const char *fname);
  ~ZtenConf();

  void readConfig (Zten* zten);
  void writeConfig (Zten* zten);

  void editDicList(QWidget* parent);
  void editGrobalConfig(QWidget* parent);


  // Global Setting Parameters
  QString FontFamily;
  int FontSize;
  int ImageScale;
  bool IncrementalMode;
  bool BookNameBeforeEntry;
  bool CursorKeyForScroll;
  bool AutoContentMode;
  bool AutoImageMode;
  bool ImageSizeLimitMode;
  int MaxImageWidth,MaxImageHeight;
  bool UseSubSupFont;
  bool SpaceSummarized;
  bool EnableQCopZtenv;
  bool EnableQCopZten;
  bool EnableQCopZdict;
  bool EnableProgressBar;
  bool EnableScrollBar;

  bool EnableSD;
  bool EnableCF;
  
  bool EnableTitleBar;

  int ResumeWait;

  QString MovieCommand;
  bool Stemming;
  int MaxHits;
  int IncrementalMaxHits;
  int IncrementalMaxHitsEach;
  int MultiMaxHits;
  int KeywordMaxHits;
  int GroupNumber;
  int CurrentMatch;
  int MaxContentLength;

  QString GroupName[MAX_DIC_GROUPS+2];

  bool StatusToolbar, BrowseToolbar, EditToolbar, SearchToolbar;

  int KeyConfigGroup;
  KeyConfig keyconf[3][KEYCONF_COMMANDS];

  bool EnableClipSearch;
  int ClipSearchMaxHits;
  int ClipSearchMaxHitsEach;
  int ClipSearchMaxDicts;
  bool clipSearchMode;

 private:
  QString configFileName;
};

extern ZtenConf* config;

#endif
