/*                                                            -*- C -*-
 * Copyright (c) 2004 Takashi Nemoto 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef ZTENDUMP_H
#define ZTENDUMP_H
#include <qdialog.h>
#include "qbookentry.h"

class QScrollView;
class QLabel;
class QImage;

struct ClickRect {
  int x0,y0,x1,y1;
  EB_Position addr;
  ClickRect(int x0, int y0, int x1, int y1, int page, int offset);
};

class ZtenImage : public QDialog
{
  Q_OBJECT
public:
  ZtenImage (QWidget* parent = 0, const char *name = 0, 
	     bool modal = FALSE, WFlags fl = 0);
  ~ZtenImage ();

  void setImage(const QImage& qi, const QString& str);
  void addArea(int x0, int y0, int x1, int y1, int page, int offset);
  QScrollView* view;
  QLabel* image;
  QLabel* caption;
  QArray<ClickRect> area;
  EB_Position pos;
  bool findArea(int x, int y, EB_Position& pos);
  int page() { return pos.page; };
  int offset() { return pos.offset; };
 protected:
  bool eventFilter (QObject *o, QEvent *e);
protected slots:
  virtual void accept ();
};

#endif // ZTENBOOK_H
