#ifndef __ZTENTEXT_H__
#define __ZTENTEXT_H__

#define ZTEN_HOOK_BEGIN (EB_NUMBER_OF_HOOKS) 

#define ZTEN_HOOK_BEGIN_EBXA_SOUND (ZTEN_HOOK_BEGIN)
#define ZTEN_HOOK_END_EBXA_SOUND (ZTEN_HOOK_BEGIN_EBXA_SOUND+1)
#define ZTEN_HOOK_BEGIN_DDCH10_GAIJI (ZTEN_HOOK_END_EBXA_SOUND+1)
#define ZTEN_HOOK_END_DDCH10_GAIJI (ZTEN_HOOK_BEGIN_DDCH10_GAIJI+1)

#define ZTEN_NUMBER_OF_HOOKS (ZTEN_HOOK_END_DDCH10_GAIJI+1)

typedef struct ZTEN_Hookset_Struct ZTEN_Hookset;

#ifdef __cplusplus
extern "C" {
#endif
  struct ZTEN_Hookset_Struct {
    EB_Hook hooks[ZTEN_NUMBER_OF_HOOKS];
#ifdef EB_ENABLE_PTHREAD
    EB_Lock lock;
#endif
  };

  void zten_initialize_hookset(ZTEN_Hookset *hookset);
  void zten_finalize_hookset(ZTEN_Hookset *hookset);
  EB_Error_Code zten_set_hook(ZTEN_Hookset *hookset, const EB_Hook *hook);
  EB_Error_Code zten_set_hooks(ZTEN_Hookset *hookset, const EB_Hook *hook);
  EB_Error_Code
  zten_read_text(EB_Book *book, EB_Appendix *appendix, ZTEN_Hookset *hookset,
		 void *container, size_t text_max_length, char *text, 
		 ssize_t *text_length);
  EB_Error_Code
  zten_read_heading(EB_Book *book, EB_Appendix *appendix, 
		    ZTEN_Hookset *hookset, void *container, 
		    size_t text_max_length, char *text, ssize_t *text_length);

  extern ZTEN_Hookset zten_default_hookset;
  
#ifdef __cplusplus
};
#endif

#endif
